import java.awt.*; 
import java.awt.image.*; 

public class GreyScaleFilter extends RGBImageFilter { 

 	public GreyScaleFilter() {
	  canFilterIndexColorModel = true; 
	 } 

	 /* skonvertujeme farebn pixle pomocou 
	 algoritmu odpovedajcemu RGB pecifikcii */ 
	 public int filterRGB(int x, int y, int pixel) { 

	 // zskame priemern RGB intenzitu 
	 int red = (pixel & 0x00ff0000) >> 16; 
	 int green = (pixel & 0x0000ff00) >> 8; 
	 int blue = pixel & 0x000000ff; 

	 int luma = (int) (0.299*red + 0.587*green + 0.114*blue); 

	 // vrtime hodnotu pre kad RGB komponent 
	 return (0xff << 24) | (luma << 16) | (luma << 8) | luma; 
	} 	
} 